diff --git a/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelBlock.java b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelBlock.java
index 4d6042d6e..a42708629 100644
--- a/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelBlock.java
+++ b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelBlock.java
@@ -3,7 +3,12 @@ package net.minecraft.client.render.item.model;
 import net.minecraft.client.render.block.color.BlockColorDispatcher;
 import net.minecraft.client.render.block.model.BlockModel;
 import net.minecraft.client.render.block.model.BlockModelDispatcher;
-import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.render.block.model.BlockModelStandard;
+import net.minecraft.client.render.renderer.BlendFactor;
+import net.minecraft.client.render.renderer.GLRenderer;
+import net.minecraft.client.render.renderer.Shaders;
+import net.minecraft.client.render.renderer.State;
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.core.block.Block;
@@ -12,8 +17,7 @@ import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.item.block.ItemBlock;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
-import org.lwjgl.opengl.GL11;
-import org.lwjgl.opengl.GL12;
+import org.joml.Math;
 import org.useless.dragonfly.DisplayPos;
 
 public class ItemModelBlock extends ItemModelStandard {
@@ -22,38 +26,34 @@ public class ItemModelBlock extends ItemModelStandard {
     public ItemModelBlock(ItemBlock<?> itemBlock){
         super(itemBlock, null);
         this.block = itemBlock.getBlock();
-        this.blockModel = BlockModelDispatcher.getInstance().getDispatch(block);
-        icon = blockModel.getOverlayTexture(0);
+        this.blockModel = BlockModelDispatcher.getInstance().getDispatch(this.block);
+        this.icon = this.blockModel.getOverlayTexture(0);
     }
 
     @Override
     public @NotNull IconCoordinate getIcon(@Nullable Entity entity, ItemStack itemStack) {
-        return this.blockModel.getOverlayTexture(itemStack.getMetadata());
+        IconCoordinate overlay = this.blockModel.getOverlayTexture(itemStack.getMetadata());
+        return overlay != null ? overlay : BlockModelStandard.BLOCK_TEXTURE_UNASSIGNED;
     }
 
     @Override
     public @NotNull DisplayPos getDisplayPos(@NotNull String id) {
-        return blockModel.shouldItemRender3d() ? this.blockModel.getItemDisplayPos(id) : super.getDisplayPos(id); // TODO this is jank fix with proper implementation
+        return this.blockModel.shouldItemRender3d() ? this.blockModel.getItemDisplayPos(id) : super.getDisplayPos(id); // TODO this is jank fix with proper implementation
     }
 
     @Override
-    public void render(@NotNull Tessellator tessellator, @Nullable Entity holder, @NotNull ItemStack itemStack, @NotNull String displayPosId, boolean items3d, int clusterSize, float brightness, float alpha, float partialTick, boolean mirrorX) {
-        if (!blockModel.shouldItemRender3d()) {
-            super.render(tessellator, holder, itemStack, displayPosId, items3d, clusterSize, brightness, alpha, partialTick, mirrorX);
+    public void render(@NotNull TessellatorGeneral tessellator, @Nullable Entity holder, @NotNull ItemStack itemStack, @NotNull String displayPosId, boolean items3d, int clusterSize, int lightmapCoord, float partialTick, boolean mirrorX) {
+        if (!this.blockModel.shouldItemRender3d()) {
+            super.render(tessellator, holder, itemStack, displayPosId, items3d, clusterSize, lightmapCoord, partialTick, mirrorX);
             return;
         }
         random.setSeed(187L);
         DisplayPos displayPos = getDisplayPos(displayPosId);
-        GL11.glTranslatef(displayPos.tx, displayPos.ty, displayPos.tz);
-        GL11.glRotatef(displayPos.rx, 1, 0, 0);
-        GL11.glRotatef(displayPos.ry, 0, 1, 0);
-        GL11.glRotatef(displayPos.rz, 0, 0, 1);
-        GL11.glScalef(displayPos.sx, displayPos.sy, displayPos.sz);
-        int color = getColor(itemStack);
-        float r = net.minecraft.core.util.helper.Color.redFromInt(color)/255f;
-        float g = net.minecraft.core.util.helper.Color.greenFromInt(color)/255f;
-        float b = net.minecraft.core.util.helper.Color.blueFromInt(color)/255f;
-        GL11.glColor4f(brightness * r, brightness * g, brightness * b, alpha);
+        GLRenderer.modelM4f().translate(displayPos.tx, displayPos.ty, displayPos.tz);
+        GLRenderer.modelM4f().rotateX(Math.toRadians(displayPos.rx));
+        GLRenderer.modelM4f().rotateY(Math.toRadians(displayPos.ry));
+        GLRenderer.modelM4f().rotateZ(Math.toRadians(displayPos.rz));
+        GLRenderer.modelM4f().scale(displayPos.sx, displayPos.sy, displayPos.sz);
         for (int i = 0; i < clusterSize; i++) {
             float rOffX = 0;
             float rOffY = 0;
@@ -63,57 +63,56 @@ public class ItemModelBlock extends ItemModelStandard {
                 rOffY = ((random.nextFloat() * 2.0F - 1.0F) * 0.2F) / displayPos.sy;
                 rOffZ = ((random.nextFloat() * 2.0F - 1.0F) * 0.2F) / displayPos.sz;
             }
-            GL11.glTranslatef(rOffX, rOffY, rOffZ);
-            renderSingle(tessellator, holder, itemStack, items3d, brightness, alpha, partialTick, mirrorX);
-            GL11.glTranslatef(-rOffX, -rOffY, -rOffZ);
+            GLRenderer.modelM4f().translate(rOffX, rOffY, rOffZ);
+            renderSingle(tessellator, holder, itemStack, items3d, lightmapCoord, getColor(itemStack), partialTick, mirrorX);
+            GLRenderer.modelM4f().translate(-rOffX, -rOffY, -rOffZ);
         }
     }
 
     @Override
-    protected void renderSingle(@NotNull Tessellator tessellator, @Nullable Entity holder, @NotNull ItemStack itemStack, boolean items3d, float brightness, float alpha, float partialTick, boolean mirrorX) {
-        if (!blockModel.shouldItemRender3d()) {
-            super.renderSingle(tessellator, holder,itemStack, items3d, brightness, alpha, partialTick, mirrorX);
+    protected void renderSingle(@NotNull TessellatorGeneral tessellator, @Nullable Entity holder, @NotNull ItemStack itemStack, boolean items3d, int lightmapCoord, int color, float partialTick, boolean mirrorX) {
+        if (!this.blockModel.shouldItemRender3d()) {
+            super.renderSingle(tessellator, holder, itemStack, items3d, lightmapCoord, color, partialTick, mirrorX);
         } else {
-            TextureRegistry.blockAtlas.bind();
-            blockModel.renderStandalone(tessellator, itemStack.getMetadata(), brightness, alpha, null);
+            TextureRegistry.worldAtlas.bind();
+            this.blockModel.renderStandalone(tessellator, itemStack.getMetadata(), lightmapCoord);
         }
     }
 
     @Override
-    public void renderGui(@NotNull Tessellator tessellator, @Nullable Entity holder, @NotNull ItemStack itemStack, int x, int y, float brightness, float alpha, float partialTick) {
-        if (!blockModel.shouldItemRender3d()) {
-            super.renderGui(tessellator, holder, itemStack, x, y, brightness, alpha, partialTick);
+    public void renderGui(@NotNull TessellatorGeneral tessellator, @Nullable Entity holder, @NotNull ItemStack itemStack, int x, int y, int lightmapCoord, float partialTick) {
+        if (!this.blockModel.shouldItemRender3d()) {
+            super.renderGui(tessellator, holder, itemStack, x, y, lightmapCoord, partialTick);
             return;
         }
-        GL11.glPushMatrix();
-        GL11.glEnable(GL11.GL_BLEND);
-        GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
-        GL11.glEnable(GL11.GL_CULL_FACE);
-        GL11.glTranslatef(x + 8, y + 8, 8);
-        GL11.glScalef(16, -16, 16);
-        render(tessellator, holder, itemStack, DisplayPos.GUI, false, 1, brightness, alpha, partialTick, false);
-        GL11.glDisable(GL11.GL_CULL_FACE);
-        GL11.glDisable(GL11.GL_BLEND);
-        GL11.glPopMatrix();
+        GLRenderer.pushFrame();
+        GLRenderer.setShader(Shaders.WORLD);
+        GLRenderer.enableState(State.BLEND);
+        GLRenderer.setBlendFunc(BlendFactor.SRC_ALPHA, BlendFactor.ONE_MINUS_SRC_ALPHA);
+        GLRenderer.enableState(State.CULL_FACE);
+        GLRenderer.modelM4f().translate(x + 8, y + 8, 8);
+        GLRenderer.modelM4f().scale(16f, -16f, 16f);
+        render(tessellator, holder, itemStack, DisplayPos.GUI, false, 1, lightmapCoord, partialTick, false);
+        GLRenderer.popFrame();
     }
 
     @Override
-    public void renderItemEntity(@NotNull Tessellator tessellator, @NotNull ItemStack itemStack, boolean items3d, int clusterSize, int ticks, float yaw, float brightness, float alpha, float partialTick) {
-        if (!blockModel.shouldItemRender3d()) {
-            super.renderItemEntity(tessellator, itemStack, items3d, clusterSize, ticks, yaw, brightness, alpha, partialTick);
+    public void renderItemEntity(@NotNull TessellatorGeneral tessellator, @NotNull ItemStack itemStack, boolean items3d, int clusterSize, int ticks, float yaw, int lightmap, float partialTick) {
+        if (!this.blockModel.shouldItemRender3d()) {
+            super.renderItemEntity(tessellator, itemStack, items3d, clusterSize, ticks, yaw, lightmap, partialTick);
             return;
         }
-        GL11.glEnable(GL12.GL_RESCALE_NORMAL);
-        GL11.glEnable(GL11.GL_BLEND);
-        GL11.glRotated(yaw, 0, 1, 0);
-        render(tessellator, null, itemStack, DisplayPos.GROUND, items3d, clusterSize, brightness, alpha, partialTick, false);
-        GL11.glDisable(GL11.GL_BLEND);
-        GL11.glDisable(GL12.GL_RESCALE_NORMAL);
+//        GL11.glEnable(GL12.GL_RESCALE_NORMAL);
+        GLRenderer.enableState(State.BLEND);
+        GLRenderer.modelM4f().rotateY(Math.toRadians(yaw));
+        render(tessellator, null, itemStack, DisplayPos.GROUND, items3d, clusterSize, lightmap, partialTick, false);
+        GLRenderer.disableState(State.BLEND);
+//        GL11.glDisable(GL12.GL_RESCALE_NORMAL);
     }
 
     @Override
     public int getColor(ItemStack stack)
     {
-        return BlockColorDispatcher.getInstance().getDispatch(block).getFallbackColor(stack.getMetadata(), 0);
+        return BlockColorDispatcher.getInstance().getDispatch(this.block).getFallbackColor(stack.getMetadata(), 0);
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelBow.java b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelBow.java
index 665a70ba6..d7e1c3749 100644
--- a/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelBow.java
+++ b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelBow.java
@@ -1,7 +1,8 @@
 package net.minecraft.client.render.item.model;
 
 import net.minecraft.client.entity.player.PlayerRemote;
-import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.render.renderer.GLRenderer;
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.monster.MobSkeleton;
 import net.minecraft.core.entity.player.Player;
@@ -10,7 +11,7 @@ import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.item.Items;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
-import org.lwjgl.opengl.GL11;
+import org.joml.Math;
 
 public class ItemModelBow extends ItemModelStandard {
     public ItemModelBow(Item item, String namespace) {
@@ -18,33 +19,32 @@ public class ItemModelBow extends ItemModelStandard {
     }
 
     @Override
-    protected void renderSingle(@NotNull Tessellator tessellator, @Nullable Entity holder, @NotNull ItemStack itemStack, boolean items3d, float brightness, float alpha, float partialTick, boolean mirrorX) {
-        super.renderSingle(tessellator, holder, itemStack, items3d, brightness, alpha, partialTick, mirrorX);
+    protected void renderSingle(@NotNull TessellatorGeneral tessellator, @Nullable Entity holder, @NotNull ItemStack itemStack, boolean items3d, int lightmapCoord, int color, float partialTick, boolean mirrorX) {
+        super.renderSingle(tessellator, holder, itemStack, items3d, lightmapCoord, color, partialTick, mirrorX);
         Item nextArrow = null;
-        if (holder instanceof Player){
-            Player entityplayer = (Player)holder;
-            nextArrow = getNextArrow(entityplayer);
-        } else if (holder instanceof MobSkeleton){
-            if (((MobSkeleton) holder).attackTime < 5){
+        if (holder instanceof Player player) {
+            nextArrow = getNextArrow(player);
+        } else if (holder instanceof MobSkeleton skeleton) {
+            if (skeleton.attackTime < 5) {
                 nextArrow = Items.AMMO_ARROW;
             }
         }
-        if (nextArrow != null){
-            GL11.glPushMatrix();
+        if (nextArrow != null) {
+            GLRenderer.pushFrame();
             if (mirrorX) {
-                GL11.glRotatef(-90, 0, 0, 1);
+                GLRenderer.modelM4f().rotateZ(-Math.PI_OVER_2_f);
             } else {
-                GL11.glRotatef(90, 0, 0, 1);
+                GLRenderer.modelM4f().rotateZ(Math.PI_OVER_2_f);
             }
-            GL11.glTranslatef(0.0001f, 0.0001f, 0);
-            GL11.glScalef(1, 1, 0.999f);
-            renderCoordinate(tessellator, ItemModelDispatcher.getInstance().getDispatch(nextArrow).getIcon(holder, nextArrow.getDefaultStack()), items3d, mirrorX);
-            GL11.glPopMatrix();
+            GLRenderer.modelM4f().translate(0.0001f, 0.0001f, 0);
+            GLRenderer.modelM4f().scale(1, 1, 0.999f);
+            renderCoordinate(tessellator, ItemModelDispatcher.getInstance().getDispatch(nextArrow).getIcon(holder, nextArrow.getDefaultStack()), lightmapCoord, color, items3d, mirrorX);
+            GLRenderer.popFrame();
         }
     }
 
-    public Item getNextArrow(Player player){
-        if (player instanceof PlayerRemote){
+    public Item getNextArrow(Player player) {
+        if (player instanceof PlayerRemote) {
             int id = player.getArrowId();
             if (id < 0 || id >= Item.itemsList.length) return null;
             return Item.itemsList[id];
diff --git a/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelMap.java b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelMap.java
index 5317abc54..b522f4f53 100644
--- a/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelMap.java
+++ b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelMap.java
@@ -1,13 +1,14 @@
 package net.minecraft.client.render.item.model;
 
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.render.EntityRenderDispatcher;
+import net.minecraft.client.render.EntityRendererDispatcher;
 import net.minecraft.client.render.ItemRenderer;
 import net.minecraft.client.render.MapItemRenderer;
 import net.minecraft.client.render.PlayerSkinParser;
 import net.minecraft.client.render.entity.EntityRenderer;
 import net.minecraft.client.render.entity.MobRendererPlayer;
-import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.render.renderer.GLRenderer;
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.core.entity.Entity;
@@ -20,8 +21,7 @@ import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.saveddata.maps.ItemMapSavedData;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
-import org.lwjgl.opengl.GL11;
-import org.lwjgl.opengl.GL12;
+import org.joml.Math;
 
 public class ItemModelMap extends ItemModelStandard {
     private final Minecraft mc = Minecraft.getMinecraft();
@@ -30,102 +30,105 @@ public class ItemModelMap extends ItemModelStandard {
     public ItemModelMap(Item item, String namespace) {
         super(item, namespace);
     }
+
     @Override
-    public void renderFirstPerson(@NotNull Tessellator tessellator, @NotNull ItemRenderer itemRenderer, @NotNull Player player, @NotNull ItemStack itemStack, float brightness, float alpha, float partialTick) {
+    public void renderFirstPerson(@NotNull TessellatorGeneral tessellator, @NotNull ItemRenderer itemRenderer, @NotNull Player player, @NotNull ItemStack itemStack, int lightmapCoord, float partialTick) {
         // The map renders very differently from any other item, so has its own custom first person render code
         if (ItemMap.hasInitialized(itemStack)) {
-            GL11.glPushMatrix();
-            GL11.glEnable(GL12.GL_RESCALE_NORMAL);
+            GLRenderer.pushFrame();
+//            GL11.glEnable(GL12.GL_RESCALE_NORMAL);
 
             final float rotationPitch = player.xRotO + (player.xRot - player.xRotO) * partialTick;
             final float swingProgress = player.getSwingProgress(partialTick);
             final float f_z = MathHelper.sin(swingProgress * MathHelper.PI);
             final float f_x = MathHelper.sin(MathHelper.sqrt_float(swingProgress) * MathHelper.PI);
-            GL11.glTranslatef(-f_x * 0.4F, MathHelper.sin(MathHelper.sqrt_float(swingProgress) * MathHelper.PI * 2.0F) * 0.2F, -f_z * 0.2F);
+            GLRenderer.modelM4f().translate(-f_x * 0.4F, MathHelper.sin(MathHelper.sqrt_float(swingProgress) * MathHelper.PI * 2.0F) * 0.2F, -f_z * 0.2F);
 
             float f_val = MathHelper.clamp((1.0F - rotationPitch / 45F) + 0.1F, 0, 1);
             f_val = -MathHelper.cos(f_val * MathHelper.PI) * 0.5F + 0.5F;
             final float zOff = 0.8F * -0.9F;
-            GL11.glTranslatef(0.0F, (-(1.0F - itemRenderer.getEquippedProgress(partialTick)) * 1.2F - f_val * 0.5F) + 0.04F, zOff); // Place map at right distance from camera
-            GL11.glRotatef(90F, 0.0F, 1.0F, 0.0F);
-            GL11.glRotatef(f_val * -85F, 0.0F, 0.0F, 1.0F);
-            GL11.glEnable(GL12.GL_RESCALE_NORMAL);
+            GLRenderer.modelM4f().translate(0.0F, (-(1.0F - itemRenderer.getEquippedProgress(partialTick)) * 1.2F - f_val * 0.5F) + 0.04F, zOff); // Place map at right distance from camera
+            GLRenderer.modelM4f().rotateY(Math.PI_OVER_2_f);
+            GLRenderer.modelM4f().rotateZ(Math.toRadians(f_val * -85F));
+//            GL11.glEnable(GL12.GL_RESCALE_NORMAL);
 
             // Render both player arms
-            mc.textureManager.bindDownloadableTexture(mc.thePlayer.skinURL, mc.thePlayer.getEntityTexture(), mc.thePlayer.slimModel ? PlayerSkinParser.instanceAlex : PlayerSkinParser.instanceSteve);
-            MobRendererPlayer playerRenderer = (MobRendererPlayer) (EntityRenderer<? extends Entity>) EntityRenderDispatcher.instance.getRenderer(mc.thePlayer);
-
-            GL11.glPushMatrix();
-            GL11.glTranslatef(-0F, -0.6F, -1.1F);
-            GL11.glRotatef(180, 0, 1, 0);
-            GL11.glRotatef(-45, 1.0F, 0.0F, 0.0F);
-            GL11.glRotatef(90F - 59F, 0.0F, 0.0F, 1.0F);
-            GL11.glRotatef(65, 0.0F, 1.0F, 0.0F);
-            GL11.glPushMatrix();
-            GL11.glScalef(1/16f, 1/16f, -1/16f);
-            GL11.glTranslatef(0, 16, 0);
-            GL11.glRotatef(180, 1, 0, 0);
-            GL11.glTranslatef(0, -16, 0);
-            GL11.glTranslatef(0, 8, 0);
-            playerRenderer.drawFirstPersonHand(Tessellator.instance, mc.thePlayer, true);
-            GL11.glPopMatrix();
-            GL11.glPopMatrix();
-            GL11.glPushMatrix();
-            GL11.glTranslatef(-0F, -0.6F, 1.1F);
-            GL11.glRotatef(-45, 1.0F, 0.0F, 0.0F);
-            GL11.glRotatef(-90F + 59F, 0.0F, 0.0F, 1.0F);
-            GL11.glRotatef(-65, 0.0F, 1.0F, 0.0F);
-            GL11.glPushMatrix();
-            GL11.glScalef(1/16f, 1/16f, -1/16f);
-            GL11.glTranslatef(0, 16, 0);
-            GL11.glRotatef(180, 1, 0, 0);
-            GL11.glTranslatef(0, -16, 0);
-            GL11.glTranslatef(0, 8, 0);
-            playerRenderer.drawFirstPersonHand(Tessellator.instance, mc.thePlayer, false);
-            GL11.glPopMatrix();
-            GL11.glPopMatrix();
+            this.mc.textureManager.bindDownloadableTexture(this.mc.thePlayer.skinURL, this.mc.thePlayer.getEntityTexture(), this.mc.thePlayer.slimModel ? PlayerSkinParser.instanceAlex : PlayerSkinParser.instanceSteve);
+            MobRendererPlayer playerRenderer = (MobRendererPlayer) (EntityRenderer<? extends Entity>) EntityRendererDispatcher.instance.getRenderer(this.mc.thePlayer);
+
+            GLRenderer.pushFrame();
+            GLRenderer.modelM4f().translate(-0F, -0.6F, -1.1F);
+            GLRenderer.modelM4f().rotateY(Math.PI_f);
+            GLRenderer.modelM4f().rotateX(-Math.PI_OVER_4_f);
+            GLRenderer.modelM4f().rotateZ(Math.toRadians(90F - 59F));
+            GLRenderer.modelM4f().rotateY(Math.toRadians(65));
+
+            GLRenderer.pushFrame();
+            GLRenderer.modelM4f().scale(1 / 16f, 1 / 16f, -1 / 16f);
+            GLRenderer.modelM4f().translate(0, 16, 0);
+            GLRenderer.modelM4f().rotateX(Math.PI_f);
+            GLRenderer.modelM4f().translate(0, -16, 0);
+            GLRenderer.modelM4f().translate(0, 8, 0);
+            playerRenderer.drawFirstPersonHand(GLRenderer.getTessellator(), this.mc.thePlayer, true);
+            GLRenderer.popFrame();
+            GLRenderer.popFrame();
+
+            GLRenderer.pushFrame();
+            GLRenderer.modelM4f().translate(-0F, -0.6F, 1.1F);
+            GLRenderer.modelM4f().rotateX(-Math.PI_OVER_4_f);
+            GLRenderer.modelM4f().rotateZ(Math.toRadians(-90F + 59F));
+            GLRenderer.modelM4f().rotateY(Math.toRadians(-65));
+            GLRenderer.pushFrame();
+            GLRenderer.modelM4f().scale(1 / 16f, 1 / 16f, -1 / 16f);
+            GLRenderer.modelM4f().translate(0, 16, 0);
+            GLRenderer.modelM4f().rotateX(Math.PI_f);
+            GLRenderer.modelM4f().translate(0, -16, 0);
+            GLRenderer.modelM4f().translate(0, 8, 0);
+            playerRenderer.drawFirstPersonHand(GLRenderer.getTessellator(), this.mc.thePlayer, false);
+            GLRenderer.popFrame();
+            GLRenderer.popFrame();
 
 
             final float f_val3 = MathHelper.sin(swingProgress * swingProgress * MathHelper.PI);
             final float f_val4 = MathHelper.sin(MathHelper.sqrt_float(swingProgress) * MathHelper.PI);
-            GL11.glRotatef(-f_val3 * 20F, 0.0F, 1.0F, 0.0F);
-            GL11.glRotatef(-f_val4 * 20F, 0.0F, 0.0F, 1.0F);
-            GL11.glRotatef(-f_val4 * 80F, 1.0F, 0.0F, 0.0F);
+            GLRenderer.modelM4f().rotateY(Math.toRadians(-f_val3 * 20F));
+            GLRenderer.modelM4f().rotateZ(Math.toRadians(-f_val4 * 20F));
+            GLRenderer.modelM4f().rotateX(Math.toRadians(-f_val4 * 80F));
 
             final float scale1 = 0.38F;
-            GL11.glScalef(scale1, scale1, scale1);
-            GL11.glRotatef(90F, 0.0F, 1.0F, 0.0F);
-            GL11.glRotatef(180F, 0.0F, 0.0F, 1.0F);
-            GL11.glTranslatef(-1F, -1F, 0.0F);
+            GLRenderer.modelM4f().scale(scale1, scale1, scale1);
+            GLRenderer.modelM4f().rotateY(Math.PI_OVER_2_f);
+            GLRenderer.modelM4f().rotateZ(Math.PI_f);
+            GLRenderer.modelM4f().translate(-1F, -1F, 0.0F);
 
             final float scale2 = 0.015625F;
-            GL11.glScalef(scale2, scale2, scale2);
+            GLRenderer.modelM4f().scale(scale2, scale2, scale2);
 
-            GL11.glNormal3f(0.0F, 0.0F, -1F);
+//            GL11.glNormal3f(0.0F, 0.0F, -1F);
 
             // Render paper background of map
-            mc.textureManager.bindTexture(mc.textureManager.loadTexture("/assets/minecraft/textures/misc/mapbg.png"));
+            this.mc.textureManager.bindTexture(this.mc.textureManager.loadTexture("/assets/minecraft/textures/misc/mapbg.png"));
             tessellator.startDrawingQuads();
             final byte expansion = 7; // makes the edges extend around the actual map data by a bit
-            tessellator.addVertexWithUV(-expansion,     128 + expansion, 0.0D, 0.0D, 1.0D);
-            tessellator.addVertexWithUV(128 + expansion,128 + expansion, 0.0D, 1.0D, 1.0D);
-            tessellator.addVertexWithUV(128 + expansion,-expansion,      0.0D, 1.0D, 0.0D);
-            tessellator.addVertexWithUV(-expansion,     -expansion,      0.0D, 0.0D, 0.0D);
+            tessellator.addVertexWithUV(-expansion, 128 + expansion, 0.0D, 0.0D, 1.0D);
+            tessellator.addVertexWithUV(128 + expansion, 128 + expansion, 0.0D, 1.0D, 1.0D);
+            tessellator.addVertexWithUV(128 + expansion, -expansion, 0.0D, 1.0D, 0.0D);
+            tessellator.addVertexWithUV(-expansion, -expansion, 0.0D, 0.0D, 0.0D);
             tessellator.draw();
 
-            ItemMapSavedData mapData = Items.MAP.getOrCreateSavedData(itemStack, mc.currentWorld);
+            ItemMapSavedData mapData = Items.MAP.getOrCreateSavedData(itemStack, this.mc.currentWorld);
             if (mapData != null) {
-                renderMapInstance.renderMap(tessellator, mapData, brightness);
+                this.renderMapInstance.renderMap(tessellator, mapData);
             }
-            GL11.glPopMatrix();
+            GLRenderer.popFrame();
         } else {
-            super.renderFirstPerson(tessellator, itemRenderer, player, itemStack, brightness, alpha, partialTick);
+            super.renderFirstPerson(tessellator, itemRenderer, player, itemStack, lightmapCoord, partialTick);
         }
     }
 
     @Override
-    public @NotNull IconCoordinate getIcon(@Nullable Entity entity, ItemStack itemStack){
-        if (!ItemMap.hasInitialized(itemStack)){
+    public @NotNull IconCoordinate getIcon(@Nullable Entity entity, ItemStack itemStack) {
+        if (!ItemMap.hasInitialized(itemStack)) {
             return TextureRegistry.getTexture("minecraft:item/map_blank");
         }
         return super.getIcon(entity, itemStack);
diff --git a/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelNone.java b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelNone.java
index 2587cc04a..2d01d27c5 100644
--- a/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelNone.java
+++ b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelNone.java
@@ -3,7 +3,7 @@ package net.minecraft.client.render.item.model;
 import net.minecraft.client.render.TextureManager;
 import net.minecraft.client.render.font.FontRenderer;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
-import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.item.ItemStack;
 import org.jetbrains.annotations.NotNull;
@@ -16,12 +16,12 @@ public class ItemModelNone extends ItemModel{
 
 
     @Override
-    public void render(@NotNull final Tessellator tessellator, @Nullable final Entity holder, @NotNull final ItemStack itemStack, @NotNull final String displayPosId, final boolean items3d, final int clusterSize, final float brightness, final float alpha, final float partialTick, final boolean mirrorX) {
+    public void render(@NotNull final TessellatorGeneral tessellator, @Nullable final Entity holder, @NotNull final ItemStack itemStack, @NotNull final String displayPosId, final boolean items3d, final int clusterSize, int lightmapCoord, final float partialTick, final boolean mirrorX) {
 
     }
 
     @Override
-    public void renderItemOverlayIntoGUI(@NotNull final Tessellator tessellator, @NotNull final FontRenderer fontRenderer, @NotNull final TextureManager textureManager, @NotNull final ItemStack itemstack, final int x, final int y, @Nullable final String override, final float alpha) {
+    public void renderItemOverlayIntoGUI(@NotNull final TessellatorGeneral tessellator, @NotNull final FontRenderer fontRenderer, @NotNull final TextureManager textureManager, @NotNull final ItemStack itemstack, final int x, final int y, @Nullable final String override, final float alpha) {
 
     }
 
